library CPAmanagement;



uses
  SysUtils,
  Classes,
  tools in 'tools.pas',
  fileType in 'fileType.pas',
  filetools in 'filetools.pas',
  Types in 'Types.pas',
  Geredata in 'Geredata.pas';

{$R *.RES}


//Error message codes
// -1     'Unknown error !'
// 0      'File read successfully'
// 1      ' Unable to read the image (missing or corrupted data)'
// 2      'Unknown compressing method !'
// 3      'Corrupted data'
// 4      'Bad Huffman header'
// 5      'Data corrupted (bad Huffman header)'
// 6      'Unable to read the Huffman header'
// 7      'Bad file signature'
// 


procedure SaveCPA(Name:PChar;
                   HighValue,LowValue:TThreshold;Infos_Image:TInfos_Image;
                   SizeX,SizeY:Integer;TypeData:Integer;Image:Pointer;NbrePlan:Integer;
                   var ErrorCode:Integer); stdcall;
begin
 ErrorCode:=-1;
 try
 filetools.WriteCPA(Name,HighValue,LowValue,Infos_Image,SizeX,SizeY,TypeData,Image,NbrePlan,Nil);
 ErrorCode:=0;
 except
  on E:EErrorLoadFile do
   ErrorCode:=E.getCode;
 end;
end;



procedure  LoadCPA(Name:PChar;
                  var HighValue,LowValue:TThreshold;var Infos_Image:TInfos_Image;
                  var SizeX,SizeY:Integer;var TypeData:Integer;var Image:Pointer;var NbrePlan:Integer;
                  var ErrorCode:Integer); stdcall
begin
 ErrorCode:=-1;
 try
 filetools.LoadCPA(Name,HighValue,LowValue,Infos_Image,SizeX,SizeY,TypeData,Image,NbrePlan,Nil);
 ErrorCode:=0;
 except
  on E:EErrorLoadFile do
  begin
   Image:=Nil;
   ErrorCode:=E.getCode;
  end;
 end;
end;

//Release the image memory after a call to LoadCPA
procedure ReleaseMemory(SizeX,SizeY:Integer;TypeData:Integer;Image:Pointer;NbPlan:Integer); stdcall
begin
 if Image<>Nil then
  FreeImage(SizeX,SizeY,TypeData,Image,NbPlan);
end;


Function  GetCPARelease:Pchar; stdcall
begin
 Result:='Version 4D Magic Mumber = $07C1E1FD';
end;


exports
  SaveCPA        name    'SaveCPA',
  LoadCPA        name    'LoadCPA',
  ReleaseMemory  name    'ReleaseMemory',
  GetCPARelease  name    'GetCPARelease';
begin
end.
