unit testDLL;

interface



const DimVec=45*2;
      MaxMotClefFITS=200;

type

   TThreshold=array[0..2] of extended;


   TOrientation=(S,SW,W,NW,N,NE,E,SE);

   TInfos_Image=packed record
    Date        :TDateTime ;
    Heure       :TDateTime ;
    Pose        :Integer   ;  // en Ms !!

    //Img infos
    ObjectName  :String[80];
    Telescope   :string[80];
    Observateur :string[80];
    Camera      :string[80];
    Filtre      :string[80];
    Observatory :string[80];
    Focale      :Double;

    Alpha       :Double;
    Delta       :Double;
    CenterPixXAstrometrie:Integer;
    CenterPixYAstrometrie:Integer;
    PixX        :Double;
    PixY        :Double;

    DebX,DebY,
    FinX,FinY   :Integer;
    Miroir_X    :Boolean;
    Miroir_Y    :Boolean;
    BinX,BinY   :Integer;

    Wavelength    : Double ;
    Bandwidth     : Double ;
    Flux          : Double ;
    PhotometrieEtalonnage : Boolean ;
    Magnitude_Ref : Double ;
    ErrFlux_Ref   : Double ;
    Flux_Ref      : Double ;

    Diametre      : Double ; // mm
    Offset        : Double ; // Bias
    FacteurCVF    : Double ; // Convertion factor (e-/ADU)
    TemperatureCCD: Double ;
    TemperatureExt: Double ;
    Seeing        : Double;
    Latitude,
    Longitude     : Double;

    Orientation:TOrientation;

    TempsLectureCCD : Double;
    TDImode         : Boolean;
    TempLectureLigne: Double ;
    PhotometricCal  : Boolean;
    AngleCCD        : Double ;

    Comment:array[1..4] of string[80];
   end;





const CPALibrary   = 'CPAmanagement.dll';

procedure  LoadCPA(Name:PChar;
                  var HighValue,LowValue:TThreshold;var Infos_Image:TInfos_Image;
                  var SizeX,SizeY:Integer;var TypeData:Integer;var Image:Pointer;var NbrePlan:Integer;
                  var ErrorCode:Integer); stdcall;  external CPALibrary name 'LoadCPA';

//Release the image memory
procedure ReleaseMemory(SizeX,SizeY:Integer;TypeData:Integer;Image:Pointer;NbPlan:Integer); stdcall;  external CPALibrary name 'ReleaseMemory';


procedure SaveCPA(Name:PChar;
                   HighValue,LowValue:TThreshold;Infos_Image:TInfos_Image;
                   SizeX,SizeY:Integer;TypeData:Integer;Image:Pointer;NbrePlan:Integer;
                   var ErrorCode:Integer); stdcall;  external CPALibrary name 'SaveCPA';

Function VersionCPA:Pchar;  external CPALibrary name 'GetCPARelease';

implementation


end.
